uses
	Gtk
	Cairo
	
class Ventana_conversion_pdf : Window
	nuevo_texto:Entry
	nuevo_nombre:string
	caja: Box
	caja_botones:Box
	respuesta:int
	_padre:Katamotzipuina
	pagina_kopuru:int
	Ytitulo:int
	extension: TextExtents
	boton_6h:EventBox
	boton_3h:EventBox
	boton_6v:EventBox
	boton_libreto:EventBox
	verde:Gdk.RGBA
	blanco:Gdk.RGBA	
	texto_titulo:TextView
	radioboton1 :Gtk.RadioButton
	radioboton2 :Gtk.RadioButton
		
	formato:string="PDF"
	configuracion:string="6h"
	fontmax:int=70
	construct (padre : Katamotzipuina)
		_padre=padre
	init
		title=t.t("Ipuinaren formatua hautatu")
		var label_titulo= new Label(t.t("Idatzi hemen izenburua:"))
		texto_titulo= new TextView()
		verde.parse("Green")
		blanco.parse("White")
		
		boton_6h= new EventBox ()
		var img_6h= new Image.from_file (KD+"/iconos/6H2.png")
		boton_6h.add(img_6h)
		boton_6h.add_events(Gdk.EventMask.BUTTON_PRESS_MASK)
		boton_6h.button_press_event.connect(on_toma_6h)
		boton_6h.override_background_color(Gtk.StateFlags.NORMAL, verde)
		
		boton_6v= new EventBox ()
		var img_6v= new Image.from_file (KD+"/iconos/6V2.png")
		boton_6v.add(img_6v)
		boton_6v.add_events(Gdk.EventMask.BUTTON_PRESS_MASK)
		boton_6v.button_press_event.connect(on_toma_6v)
		boton_6v.override_background_color(Gtk.StateFlags.NORMAL, blanco)
		
		boton_3h= new EventBox ()
		var img_3h= new Image.from_file (KD+"/iconos/3H2.png")
		boton_3h.add(img_3h)
		boton_3h.add_events(Gdk.EventMask.BUTTON_PRESS_MASK)
		boton_3h.button_press_event.connect(on_toma_3h)
		boton_3h.override_background_color(Gtk.StateFlags.NORMAL, blanco)
		
		boton_libreto= new EventBox ()
		var img_libreto= new Image.from_file (KD+"/iconos/Libreto2.png")
		boton_libreto.add(img_libreto)
		boton_libreto.add_events(Gdk.EventMask.BUTTON_PRESS_MASK)
		boton_libreto.button_press_event.connect(on_toma_libreto)
		boton_libreto.override_background_color(Gtk.StateFlags.NORMAL, blanco)
		
		
		var boton_cancelar= new Button.from_stock(Gtk.Stock.CANCEL)
		boton_cancelar.clicked.connect(on_salir2)
		var boton_aceptar= new Button.from_stock(Gtk.Stock.OK)
		boton_aceptar.clicked.connect(on_aceptar)
		
		radioboton1 = new Gtk.RadioButton (null)
		radioboton1.set_label ("PDF")
		radioboton1.toggled.connect(on_radioboton_cambiado)
		radioboton2 = new Gtk.RadioButton.with_label (radioboton1.get_group(),"PNG")
		radioboton2.set_alignment ((float)0.0, (float)1.0)
		radioboton2.toggled.connect(on_radioboton_cambiado)
		var caja_hojas= new Box(Gtk.Orientation.HORIZONTAL,5)
		var caja_formato= new Box(Gtk.Orientation.HORIZONTAL,5)
		var caja_titulo= new Box(Gtk.Orientation.VERTICAL,5)
		var caja_total= new Box(Gtk.Orientation.VERTICAL,5)
		var caja_botones= new Box(Gtk.Orientation.HORIZONTAL,5)
		caja_hojas.add(boton_6h)
		caja_hojas.add(boton_6v)
		caja_hojas.add(boton_3h)
		caja_hojas.add(boton_libreto)
		caja_formato.add(radioboton1)
		caja_formato.add(radioboton2)
		caja_titulo.add(label_titulo)
		caja_titulo.add(texto_titulo)
		caja_botones.add(boton_cancelar)
		caja_botones.add(boton_aceptar)
		
		caja_total.add(caja_hojas)
		caja_total.add(caja_titulo)
		caja_total.add(caja_formato)
		caja_total.add(caja_botones)
		
		add(caja_total)
		show_all()
		self.delete_event.connect(on_salir)
	def on_aceptar()
		if configuracion=="6v" do on_6v()
		if configuracion=="6h" do on_6h()
		if configuracion=="3h" do on_3h()
		if configuracion=="libreto" do on_libreto()
		
	def on_radioboton_cambiado(b:ToggleButton)
		if b.get_active()
			
			if (configuracion=="libreto") and (b.label=="PNG") 
				radioboton1.set_active(true)
				formato="PDF"
			else
				formato= b.label
			
	def on_toma_3h():bool
	
		boton_3h.override_background_color(Gtk.StateFlags.NORMAL, verde)
		boton_6v.override_background_color(Gtk.StateFlags.NORMAL, blanco)
		boton_6h.override_background_color(Gtk.StateFlags.NORMAL, blanco)
		boton_libreto.override_background_color(Gtk.StateFlags.NORMAL, blanco)
		configuracion="3h"
		return true
		
	def on_toma_6h():bool
		boton_3h.override_background_color(Gtk.StateFlags.NORMAL, blanco)
		boton_6v.override_background_color(Gtk.StateFlags.NORMAL, blanco)
		boton_6h.override_background_color(Gtk.StateFlags.NORMAL, verde)
		boton_libreto.override_background_color(Gtk.StateFlags.NORMAL, blanco)
		configuracion="6h"
		return true
	
	def on_toma_6v():bool
		boton_3h.override_background_color(Gtk.StateFlags.NORMAL, blanco)
		boton_6v.override_background_color(Gtk.StateFlags.NORMAL, verde)
		boton_6h.override_background_color(Gtk.StateFlags.NORMAL, blanco)
		boton_libreto.override_background_color(Gtk.StateFlags.NORMAL, blanco)
		configuracion="6v"
		return true
	
	def on_toma_libreto():bool
		boton_3h.override_background_color(Gtk.StateFlags.NORMAL, blanco)
		boton_6v.override_background_color(Gtk.StateFlags.NORMAL, blanco)
		boton_6h.override_background_color(Gtk.StateFlags.NORMAL, blanco)
		boton_libreto.override_background_color(Gtk.StateFlags.NORMAL, verde)
		configuracion="libreto"
		return true
	
	def on_salir():bool
		self.hide()
		return true
	
	def on_salir2()
		self.hide()
	
	def inicializa(pag:int)
		self.show()
		pagina_kopuru=pag
	
	def on_libreto()
		// Ahora creamos el super pdf de 2 imagenes por cada folio en formato libro
		var paginas_imprimidas=0
		var tope=(int)((pagina_kopuru+(int)(pagina_kopuru+4)%4)/2)
		var p1=0; var p2=0
		if (pagina_kopuru%2)==0 do tope-- // De este modo si son 2 biñetas / 2 =1 entonces hace dos bueltas, para evitar esto -- reducimos 1
		for var pag=0 to tope
			dibujopdf:PdfSurface
			cs:Context
			dibujopdf = new PdfSurface( UD+"/png-pdf/total"+(pag+1).to_string()+".pdf",1130,800)
			cs = new Cairo.Context(dibujopdf)
			Ytitulo=0;
			if (pag==0) and  (texto_titulo.buffer.text!="")
				Ytitulo=100 // envia todo mas abajo para que entre el titulo en la primera página.
				var s=texto_titulo.buffer.text
				var partes= s.split("\n")
				s=""
				for var x=0 to (partes.length-1)
					if partes[x].length>s.length 
						s=partes[x]
					
				for var tamano=0 to fontmax
					cs.select_font_face("KatamotzIkasi", Cairo.FontSlant.NORMAL, Cairo.FontWeight.NORMAL)
					cs.set_font_size(tamano)
					cs.text_extents(s,out extension)
					if (extension.width>500) or (extension.height*(partes.length)>100) or (tamano==fontmax)
						ypos:double=extension.height
						for var i=0 to (partes.length-1)
							cs.set_font_size(tamano)
							cs.text_extents(partes[i],out extension)
							cs.move_to(570+(500-extension.width)/2, 20+ypos)
							cs.show_text (partes[i])
							ypos+=extension.height+20
						break
			
			
			if pag%2==1
				p1=pag
				p2= ((tope+1)*2)-(pag+1)
			else
				p2=pag
				p1= ((tope+1)*2)-(pag+1)
				
			if pagina_kopuru>p1
				cs.save()
				cs.translate(20,70)
				cs.scale(0.85 ,1.3)
				_padre.crear_contexto(cs,p1)
				cs.restore()
				
			if pagina_kopuru>p2
				cs.save()
				cs.translate(580,70+Ytitulo)
				if Ytitulo!=0
					cs.scale(0.85 ,1.1)
				else
					cs.scale(0.85 ,1.3)
				_padre.crear_contexto(cs,p2)
				cs.restore()
				
			paginas_imprimidas++
		var s=""
		for var n=1 to paginas_imprimidas
			s+= Shell.quote(UD+"/png-pdf/total" +(n.to_string())+".pdf")+" "
		try
			Process.spawn_command_line_sync ("pdftk "+s+"cat output "+Shell.quote(UD+"/PDF-2.pdf")) 
		except
			print "error"
		

	def on_3h()
		var paginas_imprimidas=0
		var tope=(int)(pagina_kopuru/3)
		if (pagina_kopuru%3)==0 do tope--
		for var pag=0 to tope
			dibujopdf:PdfSurface
			dibujopng:ImageSurface
			cs:Context
			dibujopdf = new PdfSurface( UD+"/png-pdf/total3h"+(pag+1).to_string()+".pdf",1130,800)
			dibujopng = new ImageSurface(Cairo.Format.ARGB32,1130,800)
			if formato=="PDF"
				cs = new Cairo.Context(dibujopdf)
			else
				cs = new Cairo.Context(dibujopng)
			Ytitulo=0;
			if (pag==0) and (texto_titulo.buffer.text!="")
				Ytitulo=100 // envia todo mas abajo para que entre el titulo en la primera página.
				var s=texto_titulo.buffer.text
				var partes= s.split("\n")
				s=""
				for var x=0 to (partes.length-1)
					if partes[x].length>s.length 
						s=partes[x]
					
				for var tamano=0 to fontmax
					cs.select_font_face("KatamotzIkasi", Cairo.FontSlant.NORMAL, Cairo.FontWeight.NORMAL)
					cs.set_font_size(tamano)
					cs.text_extents(s,out extension)
					if (extension.width>1000) or (extension.height*(partes.length)>100) or (tamano==fontmax)
						ypos:double=extension.height
						for var i=0 to (partes.length-1)
							cs.set_font_size(tamano)
							cs.text_extents(partes[i],out extension)
							cs.move_to(50+(1000-extension.width)/2, 120+ypos)
							cs.show_text (partes[i])
							ypos+=extension.height+20
						break
					
			
			if pagina_kopuru>pag*3+0
				
				cs.save()
				cs.translate(50,250+Ytitulo)
				cs.scale(0.55,0.55)
				_padre.crear_contexto(cs,pag*3+0)
				cs.restore()
				
			if pagina_kopuru>pag*3+1 
				cs.save()
				cs.translate(400,250+Ytitulo)
				cs.scale(0.55,0.55)
				_padre.crear_contexto(cs,pag*3+1)
				cs.restore()
				
			if pagina_kopuru>pag*3+2 
				cs.save()
				cs.translate(750,250+Ytitulo)
				cs.scale(0.55,0.55)
				_padre.crear_contexto(cs,pag*3+2)
				cs.restore()
				
			
			paginas_imprimidas++
			if formato=="PNG" do dibujopng.write_to_png(UD+"/Pag_"+(pag+1).to_string()+".png") 
		
		if formato=="PDF"
			var s=""
			for var n=1 to paginas_imprimidas
				s+= Shell.quote(UD+"/png-pdf/total3h" +(n.to_string())+".pdf")+" "
			try
				Process.spawn_command_line_sync ("pdftk "+s+"cat output "+Shell.quote(UD+"/PDF-3h.pdf"))
			except
				print "error"
		
		

	def on_6h()
		var paginas_imprimidas=0
		var tope=(int)(pagina_kopuru/6)
		if (pagina_kopuru%6)==0 do tope--
		
		for var pag=0 to tope
			dibujopdf:PdfSurface
			dibujopng:ImageSurface
			cs:Context
			dibujopdf = new PdfSurface( UD+"/png-pdf/total6h"+(pag+1).to_string()+".pdf",1130,800)
			dibujopng = new ImageSurface(Cairo.Format.ARGB32,1130,800)
					
			if formato=="PDF"
				cs = new Cairo.Context(dibujopdf)
			else
				cs = new Cairo.Context(dibujopng)
			Ytitulo=0;
			if (pag==0) and (texto_titulo.buffer.text!="") 
				Ytitulo=100 // envia todo mas abajo para que entre el titulo en la primera página.
				var s=texto_titulo.buffer.text
				var partes= s.split("\n")
				s=""
				for var x=0 to (partes.length-1)
					if partes[x].length>s.length 
						s=partes[x]
					
				for var tamano=0 to fontmax
					cs.select_font_face("KatamotzIkasi", Cairo.FontSlant.NORMAL, Cairo.FontWeight.NORMAL)
					cs.set_font_size(tamano)
					cs.text_extents(s,out extension)
					if (extension.width>1000) or (extension.height*(partes.length)>100) or  (fontmax==tamano)
						ypos:double=extension.height
						for var i=0 to (partes.length-1)
							cs.set_font_size(tamano)
							cs.text_extents(partes[i],out extension)
							cs.move_to(50+(1000-extension.width)/2, 20+ypos)
							cs.show_text (partes[i])
							ypos+=extension.height+20
						break
			if pagina_kopuru>pag*6
				cs.save()
				cs.translate(50,100+Ytitulo)
				cs.scale(0.55,0.55)
				_padre.crear_contexto(cs,pag*6+0)
				cs.restore()
				
			if pagina_kopuru>pag*6+1 
				cs.save()
				cs.translate(400,100+Ytitulo)
				cs.scale(0.55,0.55)
				_padre.crear_contexto(cs,pag*6+1)
				cs.restore()
				
			if pagina_kopuru>pag*6+2 
				cs.save()
				cs.translate(750,100+Ytitulo)
				cs.scale(0.55,0.55)
				_padre.crear_contexto(cs,pag*6+2)
				cs.restore()
				
			if pagina_kopuru>pag*6+3 
				cs.save()
				cs.translate(50,400+Ytitulo)
				cs.scale(0.55,0.55)
				_padre.crear_contexto(cs,pag*6+3)
				cs.restore()
			
			if pagina_kopuru>pag*6+4 
				cs.save()
				cs.translate(400,400+Ytitulo)
				cs.scale(0.55,0.55)
				_padre.crear_contexto(cs,pag*6+4)
				cs.restore()
			
			if pagina_kopuru>pag*6+5 
				cs.save()
				cs.translate(750,400+Ytitulo)
				cs.scale(0.55,0.55)
				_padre.crear_contexto(cs,pag*6+5)
				cs.restore()
			paginas_imprimidas++
			if formato=="PNG" do dibujopng.write_to_png(UD+"/Pag_"+(pag+1).to_string()+".png") 
		
		if formato=="PDF"
			var s=""
			for var n=1 to paginas_imprimidas
				s+= Shell.quote(UD+"/png-pdf/total6h" +(n.to_string())+".pdf")+" "
			try
				Process.spawn_command_line_sync ("pdftk "+s+"cat output "+Shell.quote(UD+"/PDF-6h.pdf"))
			except
				print "error"
		
					
	def on_6v()
		var paginas_imprimidas=0
		var tope=(int)(pagina_kopuru/6)
		if (pagina_kopuru%6)==0 do tope--
		for var pag=0 to tope
			dibujopdf:PdfSurface
			dibujopng:ImageSurface
			cs:Context
			dibujopdf = new PdfSurface( UD+"/png-pdf/total6v"+(pag+1).to_string()+".pdf",800,1130)
			dibujopng = new ImageSurface(Cairo.Format.ARGB32,800,1130)
					
			if formato=="PDF"
				cs = new Cairo.Context(dibujopdf)
			else
				cs = new Cairo.Context(dibujopng)
			Ytitulo=0;
			if (pag==0) and (texto_titulo.buffer.text!="")
				Ytitulo=100 // envia todo mas abajo para que entre el titulo en la primera página.
				var s=texto_titulo.buffer.text
				var partes= s.split("\n")
				s=""
				for var x=0 to (partes.length-1)
					if partes[x].length>s.length 
						s=partes[x]
					
				for var tamano=0 to fontmax
					cs.select_font_face("KatamotzIkasi", Cairo.FontSlant.NORMAL, Cairo.FontWeight.NORMAL)
					cs.set_font_size(tamano)
					cs.text_extents(s,out extension)
					if (extension.width>600) or (extension.height*(partes.length)>120) or  (tamano==fontmax)
						ypos:double=extension.height
						for var i=0 to (partes.length-1)
							cs.set_font_size(tamano)
							cs.text_extents(partes[i],out extension)
							cs.move_to((800-extension.width)/2, 20+ypos)
							cs.show_text (partes[i])
							ypos+=extension.height+20
						break
			
			if pagina_kopuru>pag*6
				
				cs.save()
				cs.translate(80,140+Ytitulo)
				cs.scale(0.55,0.55)
				_padre.crear_contexto(cs,pag*6+0)
				cs.restore()
				
			if pagina_kopuru>pag*6+1 
				cs.save()
				cs.translate(420,140+Ytitulo)
				cs.scale(0.55,0.55)
				_padre.crear_contexto(cs,pag*6+1)
				cs.restore()
				
			if pagina_kopuru>pag*6+2 
				cs.save()
				cs.translate(80,425+Ytitulo)
				cs.scale(0.55,0.55)
				_padre.crear_contexto(cs,pag*6+2)
				cs.restore()
				
			if pagina_kopuru>pag*6+3 
				cs.save()
				cs.translate(420,425+Ytitulo)
				cs.scale(0.55,0.55)
				_padre.crear_contexto(cs,pag*6+3)
				cs.restore()
			
			if pagina_kopuru>pag*6+4 
				cs.save()
				cs.translate(80,710+Ytitulo)
				cs.scale(0.55,0.55)
				_padre.crear_contexto(cs,pag*6+4)
				cs.restore()
			
			if pagina_kopuru>pag*6+5 
				cs.save()
				cs.translate(420,710+Ytitulo)
				cs.scale(0.55,0.55)
				_padre.crear_contexto(cs,pag*6+5)
				cs.restore()
			
			paginas_imprimidas++
			if formato=="PNG" do dibujopng.write_to_png(UD+"/Pag_"+(pag+1).to_string()+".png") 
		
		if formato=="PDF"
			var s=""
			for var n=1 to paginas_imprimidas
				s+= Shell.quote(UD+"/png-pdf/total6v" +(n.to_string())+".pdf")+" "
			try
				Process.spawn_command_line_sync ("pdftk "+s+"cat output "+Shell.quote(UD+"/PDF-6v.pdf"))
			except
				print "error"
		
			
						
